/*!
 * customnumberzeropadding Plugin for jQuery
 *
 * 쐬 S.Yoshino
 *
 * w肵̃eLXĝݓ͂ł悤ɂvOCł
 * p[^
 *  format      : 0pfBOtH[}bg
 *              : 000000 *0pfBOꂽ6̐l
 *  zerosupport : 0T|[g邩ǂ 
 *  align     : input̔zuwiE񂹁A񂹓j
 *            : left 񂹂ɂ܂
 *            : right E񂹂ɂ܂
 *            : center ɂ܂
 *
 * ֐
 *  CustomNumberZeroPaddingSetValue  : lZbg֐
 *  CustomNumberZeroPaddingGetValue  : l擾֐
 *  CustomNumberZeroPaddingGetDisplayValue : l擾֐(0܂߂Ď擾)
 *
 *
 * g
 *  $('#num1').customnumberzeropadding({format: '00000000', zerosupport: false});
 *  Enum1ɐl͂8ɖȂꍇA0Ŗ߂
 *  E0̓T|[gȂ
 *
 *  $('#num2').customnumberzeropadding({format: '00000000', zerosupport: true});
 *  Enum2ɐl͂8ɖȂꍇA0Ŗ߂
 *  E0̓T|[g
 *
 * _
 *
 * 2015/08/15 VK쐬
 */
(function($) {
    var zeroformat = new Object();     // 
    var zerosupport = new Object();     // 
    var align = new Object();      // zuʒu

    // ready֐1łsĂ邩肷֐
    function execReady() {
        if (typeof execReady.ready === 'undefined') {
            execReady.ready = false;
        } else {
            execReady.ready = true;
        }
        return execReady.ready;
    }

    $.fn.customnumberzeropadding = function (options) {
        if (this.length == 0) {
            return;
        }
        // O[oϐ
        var browserName;    // uEU
        var changeEventExecute;       // focusoutchangeCxgstO
        var changeEventExecuteValue;  // ύXO̕i[changeEventExecute̔p

        var firstSelectFlag;        // SelectԂ̃tO
        var firstClickFlag;         // SelectԂ̃tO

        var defaults = $.extend({
            'format': '0000000000',
            'zerosupport': true,
            'align': 'right'
        }, options);

        var setting = $.extend(defaults, options);

        zeroformat[this[0].id] = setting.format;
        zerosupport[this[0].id] = setting.zerosupport;
        align[this[0].id] = setting.align;

        // eLXg̔zuݒ
        $(this).css('text-align', align[this[0].id]);

        $(this).addClass('customnumberzeropadding');

        var userAgent = window.navigator.userAgent.toLowerCase();

        if (userAgent.indexOf('opera') != -1) {
            browserName = 'opera';
        } else if (userAgent.indexOf('msie') != -1) {
            browserName = 'ie';
        } else if (userAgent.indexOf('trident') != -1) {
            browserName = 'ie11';
        } else if (userAgent.indexOf('chrome') != -1) {
            browserName = 'chrome';
        } else if (userAgent.indexOf('safari') != -1) {
            browserName = 'safari';
        } else if (userAgent.indexOf('firefox') != -1) {
            browserName = 'firefox';
        } else {
            browserName = '';
        }

        // SetValue֐
        $.fn.CustomNumberZeroPaddingSetValue = function (val) {
            if (this.length == 0) {
                return;
            }
            var format = zeroformat[this[0].id];
            var zerosup = zerosupport[this[0].id];

            if (val.length == 0) {
                $(this).val('');
                return;
            }

            if (zerosup == false && val == '0') {
                $(this).val('');
                return;
            }

            var tmp = val;

            for (var i = val.length; i < format.length; i++) {
                tmp = '0' + tmp;
            }

            $(this).val(tmp);

        }

        // GetValue֐
        $.fn.CustomNumberZeroPaddingGetValue = function() {
            if (this.length == 0) {
                return '';
            }

            var val = $(this).val();
            var ret = '';

            for (var i = 0; i < val.length; i++) {
                var c = val.charAt(i);
                if (c != '0') {
                    ret = val.substring(i);
                    // [v𔲂
                    i = val.length + 1;
                }
            }

            return ret;
        }

        // GetDisplayValue֐
        $.fn.CustomNumberZeroPaddingGetDisplayValue = function () {
            if (this.length == 0) {
                return '';
            }

            return $(this).val();
        }

        $.fn.CustomNumberZeroPaddingOnSubmit = function () {
            if ($(this).val() == '') {
                return;
            }

            var val = $(this).val();
            var ret = '';

            for (var i = 0; i < val.length; i++) {
                var c = val.charAt(i);
                if (c != '0') {
                    ret = val.substring(i);
                    // [v𔲂
                    i = val.length + 1;
                }
            }

            return ret;
        }


        // readyCxg
        $(this).ready(function () {
            if(execReady() == true){
                return;
            }
            $('input.customnumberzeropadding').each(function (i) {
                var val = $(this).val();

                if (val.length == 0) {
                    return;
                }

                var num = Number(val);

                $(this).val(num);

                $(this).css('ime-mode', 'disabled');

            });
        });

        // clickCxg
        $(this).on('click', function () {
            if (firstSelectFlag == true && firstClickFlag == true) {
                firstSelectFlag = false;
                firstClickFlag = false;
            } else {
                $(this).select();
                firstSelectFlag = true;
                firstClickFlag = true;
            }
        });

        // focusinCxg
        $(this).on('focusin', function() {
            var val = $(this).val();

            if (val.length == 0) {
                return;
            }

            var num = Number(val);

            $(this).val(num);

            $(this).css('ime-mode', 'disabled');

            changeEventExecute = false;
            changeEventExecuteValue = $(this).val();

            $(this).select();

            firstSelectFlag = true;
            firstClickFlag = false;
        });

        // focusoutCxg
        $(this).on('focusout', function(e) {
            var format = zeroformat[this.id];
            var zerosup = zerosupport[this.id];

            var val = $(this).val();

            if (val.length == 0) {
                return;
            }

            if (zerosup == false && val == '0') {
                $(this).val('');
                return;
            }

            if (changeEventExecuteValue != val) {
                changeEventExecute = true;
            }


            var tmp = val;

            for (var i = val.length; i < format.length; i++) {
                tmp = '0' + tmp;
            }

            $(this).val(tmp);
            

            if (changeEventExecute == true) {
                $(this).trigger('change', [false]);
            }

        });

        // pasteCxg
        $(this).on('paste', function() {
            var format = zeroformat[this.id];
            var _this = this;
            
            setTimeout(function () {
                var val = $(_this).val();

                if (val.length > format.length) {
                    _this.val('');
                    return;
                }

                var num = Number(val);

                if (isNaN(num) == true) {
                    $(_this).val('');
                } else {
                    $(_this).val(num);
                }

            }, 10);

        });

        // keypressCxg
        $(this).on('keypress', function(e) {
            var format = zeroformat[this.id];

            var keyCode = (e.keyCode) ? e.keyCode : e.which;
            var s = String.fromCharCode(keyCode);
            if (browserName == 'ie') { // ie10܂
                if (firstSelectFlag == true && getCarretPos(this) == $(this).val().length) {
                    $(this).val('');
                    firstSelectFlag = false;
                }
            } else if (browserName == 'ie11') { // ie11ȍ~
                if (firstSelectFlag == true && getCarretPos(this) == 0 && keyCode != 9) {
                    $(this).val('');
                    firstSelectFlag = false;
                }
            } else {
                if (firstSelectFlag == true && getCarretPos(this) == 0 && keyCode != 9) {
                    $(this).val('');
                    firstSelectFlag = false;
                }
            }

            if (keyCode == 8) { // BS
                return true;
            } else if ((keyCode >= 48 && keyCode <= 57)) { // 1-10
                firstSelectFlag = false;

               // ݂̃Jbg擾
                var pos = getCarretPos(this);
                // ݂̃Jbg當̑}ʒu`FbN}
                var val = $(this).val().substring(0, pos) + s + $(this).val().substring(pos, $(this).val().length);

                if (val.length > format.length) { // ͂̒`̐̒𒴂Ƃ͓͂Ȃ
                    return false;
                } else {

                    var num = Number(val);

                    $(this).val(num);

                    // JbgʒuĐݒ肷
                    setCaretPos(this, pos + 1);

                    return false;
                }

            } else {
                //͕s
                return false;
            }
        });

        return this;
    };

    $(this).on('change', function (e) {
        if (changeEventExecute == false) {
            e.stopImmediatePropagation();
            return false;
        }

        return true;
    });

    /****************************************************************
    * @@\F eLXg{bNX̃Jbg̃|WV擾
    * @F item eLXg{bNX
    * ߂lF Jbg̃|WV
    ****************************************************************/
    function getCarretPos(item) {
        var CaretPos = 0;
        if (document.selection) { // IE
            //item.focus();         // ꂪIME-Mode܂Ȃ̂ŃRgAEg
            var Sel = document.selection.createRange();
            Sel.moveStart("character", -item.value.length);
            CaretPos = Sel.text.length;
        } else if (item.selectionStart || item.selectionStart == "0") { // Firefox, Chrome
            CaretPos = item.selectionStart;
        }
        return CaretPos;
    }

    /****************************************************************
    * @@\F eLXg{bNX̃Jbg̃|WVݒ肷
    * @F item eLXg{bNX
    *          caret_position ݒ肷Jbg̈ʒu
    * ߂lF Ȃ
    ****************************************************************/
    function setCaretPos(item, caret_position) {
        if (item.setSelectionRange) {  // Firefox, Chrome
            item.focus();
            item.setSelectionRange(caret_position, caret_position);
        } else if (item.createTextRange) { // IE
            var range = item.createTextRange();
            range.collapse(true);
            range.moveEnd("character", caret_position);
            range.moveStart("character", caret_position);
            range.select();
        }
    }

})(jQuery);
